package de.emesit.lecture.file;

import java.net.URI;
import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.spi.FileSystemProvider;

public class Exp01_FileSystem {
	
	public Exp01_FileSystem() throws Exception {
		
		FileSystem defaultFs = FileSystems.getDefault();
		System.out.println( defaultFs );
		
		URI uri = new URI( "memory:///?name=unitTest");
		FileSystem memoryFs = FileSystems.newFileSystem( uri, null );
		System.out.println( memoryFs );
		
		System.out.println( "\ninstalled providers:");

		for( FileSystemProvider fsp : FileSystemProvider.installedProviders() ){
			System.out.println( "schema:"+fsp.getScheme() +" provider:"+fsp  );
		}
		
	}
	
	public static void main(String[] args){
		try {
			new Exp01_FileSystem();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}

}
