package de.emesit.lecture.file;

import java.net.URI;
import java.nio.channels.FileChannel;
import java.nio.channels.SeekableByteChannel;
import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.nio.file.spi.FileSystemProvider;
import java.util.Iterator;
import java.util.Map;

public class Exp03_Path {
	
	public Exp03_Path() throws Exception {
		
		FileSystem fs = FileSystems.getDefault();
		Path image = fs.getPath( "E:/temp/FS7/weltraum_bilder/01.jpg");
		
		FileSystemProvider fsp = FileSystemProvider.installedProviders().get( 0 );
		Path path2 = fsp.getPath( new URI( "file:///E:/temp/FS7/weltraum_bilder/01.jpg" ));
		

		//einfacher
		Path path3 = Paths.get( new URI( "file:///E:/temp/FS7/weltraum_bilder/01.jpg" ));
		Path path4 = Paths.get( "E:/temp/FS7/weltraum_bilder/01.jpg" );
		
		
		System.out.println( "exists:"+image.exists() );		
		System.out.println( "isIdentical:"+image.isSameFile(path2));	
		System.out.println( "isIdentical:"+image.isSameFile(path3));	
		System.out.println( "isIdentical:"+image.isSameFile(path4));
		
		Map<String, ?> map = image.readAttributes( "*" );
		Iterator it = map.entrySet().iterator();
		System.out.println( "BasicFileAttributes:");
		while( it.hasNext() ){
			System.out.println( "\t"+it.next() );
		}
		System.out.println( );
		
		System.out.println( "absolute Path: "+image);
		Path baseDir = Paths.get( new URI( "file:///e:/temp/FS7")); 
		System.out.println( "base Directory:"+baseDir);
		Path relative = baseDir.relativize( image );
		System.out.println( "relativize   : "+ relative );
		System.out.println( "resolve      : "+ baseDir.resolve( relative ));
		

		baseDir = Paths.get( new URI( "file:///e:/temp/lock")); 
		System.out.println( "base Directory:"+baseDir);
		relative = baseDir.relativize( image );
		System.out.println( "relativize   : "+ relative );
		
		//cast of file channel
		SeekableByteChannel sbc = image.newByteChannel( StandardOpenOption.READ, StandardOpenOption.WRITE );
		System.out.println( "is FileChannel:" + (sbc instanceof FileChannel));
		FileChannel fc = (FileChannel) sbc;
		fc.lock();
		fc.close();
	}

	
	public static void main(String[] args){
		try {
			new Exp03_Path();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
