package de.emesit.lecture.file;

import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.nio.file.attribute.AclEntry;
import java.nio.file.attribute.AclEntryPermission;
import java.nio.file.attribute.AclEntryType;
import java.nio.file.attribute.AclFileAttributeView;
import java.nio.file.attribute.UserPrincipal;
import java.nio.file.attribute.UserPrincipalLookupService;
import java.util.List;

public class Exp07_UserPrincipal{
	
	public Exp07_UserPrincipal()throws Exception{
	    	
    	FileSystem fs = FileSystems.getDefault();
    	UserPrincipalLookupService upls = fs.getUserPrincipalLookupService();
    	
    	UserPrincipal ralph = upls.lookupPrincipalByName( "Ralph" );
    	
    	Path path = fs.getPath( "E:/temp/FS7/userDef.txt" );
    	
    	AclFileAttributeView view = path.getFileAttributeView( AclFileAttributeView.class );
    	List<AclEntry> acl = view.getAcl();
    	for( AclEntry e : acl ){
    		System.out.println( " : "+e );
    	}
    	
    
        AclEntry entry = AclEntry.newBuilder()
            .setType(AclEntryType.ALLOW)
            .setPrincipal(ralph)
            .setPermissions(AclEntryPermission.READ_DATA, AclEntryPermission.READ_ATTRIBUTES )
            .build();

        // insert ACE, re-write ACL
        acl.clear();
        acl.add(0, entry);  
        view.setAcl(acl);
       	
	}

	public static void main(String[] args){
		try {
			new Exp07_UserPrincipal();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
